<template>
	<el-dialog v-model="state.dialogVisible" width="50%" draggable title="编辑线索" destroy-on-close append-to-body @close="close">
		<el-form :model="state.ruleForm" label-width="100px" ref="ruleFormRef" :disabled="loading">
			<el-row :gutter="10">
				<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12">
					<el-form-item label="线索名称" prop="name" :rules="[{ required: true, message: '请填写线索名称', trigger: 'blur' }]">
						<el-input v-model="state.ruleForm.name" placeholder="请填写线索名称" clearable></el-input>
					</el-form-item>
				</el-col>
				<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12">
					<el-form-item label="市民红包" prop="citizenReadPackAmount" :rules="[{ required: true, message: '请填写市民红包', trigger: 'blur' }]">
						<el-input-number v-model="state.ruleForm.citizenReadPackAmount" :min="0" :precision="2" class="w100" placeholder="请填写市民红包" />
					</el-form-item>
				</el-col>
				<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12">
					<el-form-item label="网格员红包" prop="guiderReadPackAmount" :rules="[{ required: true, message: '请填写网格员红包', trigger: 'blur' }]">
						<el-input-number v-model="state.ruleForm.guiderReadPackAmount" :min="0" :precision="2" class="w100" placeholder="请填写网格员红包" />
					</el-form-item>
				</el-col>
				<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12">
					<el-form-item label="行业类型" prop="industryId" :rules="[{ required: false, message: '请选择行业类型', trigger: 'change' }]">
						<el-select v-model="state.ruleForm.industryId" placeholder="请选择行业类型" class="w100" clearable filterable>
							<el-option v-for="item in industry" :key="item.id" :label="item.name" :value="item.id" />
						</el-select>
					</el-form-item>
				</el-col>
				<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12">
					<el-form-item label="状态" prop="isEnable">
						<el-switch v-model="state.ruleForm.isEnable" inline-prompt active-text="启用" inactive-text="禁用" />
					</el-form-item>
				</el-col>
				<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12">
					<el-form-item label="排序" prop="displayOrder" :rules="[{ required: false, message: '请填写排序', trigger: 'blur' }]">
						<el-input-number v-model="state.ruleForm.displayOrder" :min="1" :precision="0" class="w100" />
					</el-form-item>
				</el-col>
			</el-row>
		</el-form>
		<template #footer>
				<span class="dialog-footer">
					<el-button @click="closeDialog" class="default-button">取 消</el-button>
					<el-button type="primary" @click="onSubmit(ruleFormRef)" :loading="loading">确 定</el-button>
				</span>
		</template>
	</el-dialog>
</template>

<script setup lang="ts" name="parameterEdit">
import { computed, onMounted, reactive, ref } from 'vue';
import { ElMessage, FormInstance } from 'element-plus';
import { throttle } from '@/utils/tools';
import { modifySettings, setitngsDetail } from '@/api/system/parameter';
import { baseClue, editClue, getClueDetail } from '@/api/snapshot/config';
// 定义子组件向父组件传值/事件
const emit = defineEmits(['updateList']);

// 定义变量内容
const state = reactive<any>({
	dialogVisible: false,
	ruleForm: {
		name:null, // 线索名称
		citizenReadPackAmount:null, // 市民红包
		guiderReadPackAmount:null, // 网格员红包
		industryId:null, // 行业类型
		isEnable: true, // 是否启用
		displayOrder:1,// 排序
	},
});
let loading = ref<boolean>(false);  // 加载状态
// 打开弹窗
const ruleFormRef = ref<RefType>();
const openDialog = async (id: string) => {
	await getBaseData();
	try {
		const res: any = await getClueDetail(id);
		state.ruleForm = res.result ?? <EmptyObjectType>{};
		state.dialogVisible = true;
	} catch (error) {
		console.log(error);
	}
};
// 关闭弹窗
const closeDialog = () => {
	state.dialogVisible = false;
};
const close = () => {
	ruleFormRef.value?.resetFields();
	ruleFormRef.value?.resetFields();
};
// 新增
const onSubmit = throttle(async (formEl: FormInstance | undefined) => {
	if (!formEl) return;
	await formEl.validate((valid: boolean) => {
		if (!valid) return;
		loading.value = true;
		editClue(state.ruleForm)
			.then(() => {
				ElMessage({
					message: '操作成功',
					type: 'success',
				});
				loading.value = false;
				closeDialog();
				emit('updateList');
			})
			.catch(() => {
				// 新增失败
				loading.value = false;
				closeDialog();
			});
	});
}, 300);
const industry = ref<EmptyArrayType>([]);
const getBaseData = async () => {
	try {
		const { result } = await baseClue();
		industry.value = result.industry;
	} catch (e) {
		console.log(e);
	}
};
// 暴露变量
defineExpose({
	openDialog,
	closeDialog,
});
</script>
